
// The publisher is not the author, just edited some stuff here and there...
// First the setInfos call. Look at how we define the background color: we load it from the SexScripts data,
// and if there is not a color under the key "advanced.bgcolor", we'll use 0x8000FF (lilac) as default

setInfos(4, "Breathe Academy", "Breathe training challenge",
		    "Unsigned, acvt927", "In progress", 0x000001, "en", ["formale", "pain", "femaledom"])

// This works because null turns into false if evaluated as a boolean. But be careful! If the saved color under
// this key is black (0x000000) it will also be evaluated as false, and 0x8000FF will be used for background
// color instead. Any other color will be loaded without any issue. But if you are in the really need of loading
// black, use the color 0x000001 instead of 0x000000

// Speed of the appearing text when shown dynamically
def textSpeed = 40

// Fade in/out speed of pictures when shown dynamically
def imageSpeed = 40

//********************************************************************//
// Default for breathe play
def countdownSpeed = 1.0
def cumScore = 50
def scoreHonesty = 5
def scoreFail = -5
def scoreLiar = -15

//Test
def timeMytimeInSeconds = loadInteger("BreatheAcademy.MyTime")
if(timeMytimeInSeconds==null)
	timeMytimeInSeconds = 60

def timeIntroInSeconds = timeMytimeInSeconds / 3
def timeBaseInSeconds = 40
def	timeGivenInSeconds = timeIntroInSeconds
def timeMaxBreakInSeconds = 4
def currentFail = 0
def currentCycle = 0
def maxFail = 3
def maxCycle = 6
def lastAttempt = 0
def hideTimeAfterCycle = 2

// Leah
def additionalBreast = 10
def additionalPussy = 10
def additionalFeet = 5
def additionalAway = 5
def additionalFailing = 10


// Now let's define some fancy closures
def showDynamically = { message ->	
	if (textSpeed <= 0) textSpeed = 0.05
	def appearedMessage = ""

	for (c in message) {
		appearedMessage += c
		show(appearedMessage)
		wait(1/textSpeed)
	}
}

def unshowDynamically = { message ->	
	if (textSpeed <= 0) textSpeed = 0.05
	def i = message.size()

	while(i > 0) {
		show(message.substring(0, i--))
		wait(1/textSpeed)
	}
	
	show(null)
}

def playSwats = { swats, time ->
	(1..swats).each {
		playBackgroundSound("sounds/swat.wav")
		wait(time)
	}
}

def	waitWithCountDownSound = 
{
	message,sound,time,speed ->
	def total = time/speed
	def totalremaining = time/speed


	(1..total).each
	{
	playBackgroundSound(sound)
	
	show(message+"\n\n"+(totalremaining*speed).toInteger() +" seconds")

	totalremaining = totalremaining - 1
	wait(speed)
	}
}

def	waitWithCountDownOnlySound = 
{
	sound,time,speed ->
	def total = time/speed
	def totalremaining = time/speed


	(1..total).each
	{
	playBackgroundSound(sound)
	totalremaining = totalremaining - 1
	wait(speed.toDouble())
	}
}

def waitWithCount = {time ->
	def startTime = getTime()
	def waitedTime = getTime()-startTime

	while ( waitedTime < time ) {
		int minutes = waitedTime / 60
		int seconds = waitedTime % 60

		def minutesExtraDigit = ""
		if (minutes < 10) minutesExtraDigit = "0"

		def secondsExtraDigit = ""
		if (seconds < 10) secondsExtraDigit = "0"

		show("\n\n"+minutesExtraDigit + minutes + ":" + secondsExtraDigit + seconds )
		

		waitedTime = getTime()-startTime
	}
}

def waitWithCountDown = {message,time ->
	time = time + 1
	def startTime = getTime()
	def waitedTime = getTime()-startTime
	def prevSecond = 999
	
	while ( waitedTime < time ) {
		int minutes = (time - waitedTime) / 60
		int seconds = (time - waitedTime) % 60

		def minutesExtraDigit = ""
		if (minutes < 10) minutesExtraDigit = "0"

		def secondsExtraDigit = ""
		if (seconds < 10) secondsExtraDigit = "0"

		if((prevSecond != seconds) && (prevSecond != 999))
		{
				playBackgroundSound("swat.wav")
		}

		show("time"+(time - waitedTime)+" "+message+"\n\n"+minutesExtraDigit + minutes + ":" + secondsExtraDigit + seconds )
		waitedTime = getTime()-startTime
		prevSecond = seconds
	}
}

def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}

	if ( itemKeys.is



() ) return null

	return itemKeys[ getRandom(itemKeys.size()) ]
}

def setImageFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)((width*it)/10), (int)((height*it)/10),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)((width*it)/10), (int)((height*it)/10), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
}

def setImageOffFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)(width/it), (int)(height/it),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)(width/it), (int)(height/it), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
	setImage(null)
}


def getLeahImage = { imageset ->
	if(imageset=="idle")
	{
		setImage("BreatheAcademy/Leah/Dark/idle"+getRandom(8)+".jpg")
	}	
	if(imageset=="introduction")
	{
		setImage("BreatheAcademy/Leah/Dark/Intro"+getRandom(9)+".jpg")
	}
	if(imageset=="holding")
	{
		setImage("BreatheAcademy/Leah/Dark/holding"+getRandom(6)+".jpg")
	}
	if(imageset=="ass")
	{
		setImage("BreatheAcademy/Leah/Dark/ass"+getRandom(6)+".jpg")
	}
	if(imageset=="punishment")
	{
		setImage("BreatheAcademy/Leah/Dark/punishment"+getRandom(8)+".jpg")
	}
	if(imageset=="happy")
	{
		setImage("BreatheAcademy/Leah/Dark/happy"+getRandom(1)+".jpg")
	}
		if(imageset=="challenge")
	{
		setImage("BreatheAcademy/Leah/Dark/challenge"+getRandom(2)+".jpg")
	}
		if(imageset=="test")
	{
		setImage("BreatheAcademy/Leah/Dark/test"+getRandom(6)+".jpg")
	}
}

def getPunishmentBasket=
{
	basket->
	if(basket=="balls")
	{
		switch(getRandom(4))
		{
		case 0:	show("I want you to slap your balls, HARD, once per second. Don't even dare thinking about skipping a single one.")
				break;
		case 1:	show("I want you to grab your balls and SQUEEZE as hard as you can "+timeGivenInSeconds+" seconds.")
				break;
		case 2:	show("I want you to use your thumb and second finger to form a tight circle above your balls, seperating them from your shaft. Tighten the ring and pull away from your body as hard as you can "+timeGivenInSeconds+" seconds.")
				break;
		case 3:	show("I want you both hands and pinch the skin on either side of your sack and pull out as hard as you can for "+timeGivenInSeconds+" seconds.")
				break;
		}
	}
	if(basket=="nipples")
	{
		switch(getRandom(3))
		{
		case 0:	show("I want you to pinch your nipples, HARD, and pull them out as far as they'll go for "+timeGivenInSeconds+" seconds.")
				break;
		case 1:	show("I want you to get on you knees and press your nipples on end of the desk. Use your thumbs to pinch your nipples against the desk and pull back as hard as you can for "+timeGivenInSeconds+" seconds.")
				break;
		case 2:	show("Use your nails to pinch your nipples as hard as you can for "+timeGivenInSeconds+" seconds.")
				break;
		}
	}
	if(basket=="spanking")
	{
		switch(getRandom(1))
		{
		case 0:	show("Perhaps a spanking will do, once for each second.")
				break;
		}
	}
}

def startLeahPunishment={

	getLeahImage("punishment")
	switch(getRandom(3))
	{
	case 0:	getPunishmentBasket("nipples")
			showButton("Ready, Mistress")
			waitWithCountDownSound("","tom.wav",timeGivenInSeconds,1.0)
			break;
	case 1:	getPunishmentBasket("balls")
			showButton("Ready, Mistress")
			waitWithCountDownSound("","tom.wav",timeGivenInSeconds,1.0)
			break;
	case 2:	getPunishmentBasket("spanking")
			showButton("Ready, Mistress")
			waitWithCountDownSound("","swat.wav",timeGivenInSeconds,1.0)
			break;
	}
	
	currentFail = currentFail + 1
	timeGivenInSeconds = timeGivenInSeconds + additionalFailing
	cumScore = cumScore + scoreFail
}

def calcAdditionalTime={

	def indicatorLiar = 1

	getLeahImage("idle")
	switch(getSelectedValue("Now be honest, did you look at my breast",["Yes, Mistress","No, Mistress"]))
	{
	case 0: getLeahImage("punishment")
			show("tsk tsk, that's additional time")
			wait(2.0)
			timeGivenInSeconds = timeGivenInSeconds + additionalBreast
			cumScore = cumScore + scoreHonesty
			indicatorLiar = 0
			break;
	case 1: show("Really? I'm impressed")
			wait(2.0)
			break;
	}

	switch(getSelectedValue("Did you look at my pussy",["Yes, Mistress","No, Mistress"]))
	{
	case 0: getLeahImage("punishment")
			show("tsk tsk, that's additional time")
			wait(2.0)
			timeGivenInSeconds = timeGivenInSeconds + additionalPussy
			cumScore = cumScore + scoreHonesty
			indicatorLiar = 0
			break;
	case 1: show("Really? I'm impressed")
			wait(2.0)
			break;
	}

	if(indicatorLiar == 1)
	{
		switch(getSelectedValue("Did you look away from my eyes at all",["Yes, Mistress","No, Mistress"]))
		{
		case 0: getLeahImage("punishment")
				show("tsk tsk, that's additional time")
				wait(2.0)
				timeGivenInSeconds = timeGivenInSeconds + additionalAway
				cumScore = cumScore + scoreHonesty
				indicatorLiar = 0		
				break;
		case 1: 
				getLeahImage("punishment")
				show("Do you really expect me to believe that you stared into my eyes the ENTIRE time")
				wait(1.5)
				show("Well, I don't believe you")
				wait(1.5)
				getLeahImage("punishment")
				show("I'm adding additional time for lying")
				wait	(1.5)
				timeGivenInSeconds = timeGivenInSeconds + additionalFailing
				cumScore = cumScore + scoreLiar
				break;
		}
		
	}
}

def startLeahCumChance=
{
	show(cumScore)
	wait(2.0)
	def indicatorNope = 0
	if(cumScore < 0)
	{
		indicatorNope = 1
	}
	else
	{
		getLeahImage("introduction")	
		show("Lets see...")
		wait(1.5)
		show("Hold your breath for me!")
		wait(2)
		getLeahImage("holding")
		waitWithCountDownSound("Why don't you get started and give me "+(1/1.0).toInteger()+" stroke per second","tom.wav",timeGivenInSeconds,1.0)
		waitWithCountDownSound("Now...give me "+(1/0.5).toInteger()+" stroke per second","tom.wav",30,0.5)
		waitWithCountDownSound("now...give me "+(1/0.25).toInteger()+" stroke per second","tom.wav",20,0.25)
		waitWithCountDownSound("I want you to stroke as hard and fast as you can and cum when I say so","tom.wav",10,0.1)
		show("ready..?")
		wait(2.0)	

		textSpeed = 2
		if(cumScore < getRandom(100))
		{
			indicatorNope = 1
			showDynamically("5....4....3....2....1..........STOP!")
			getLeahImage("punishment")
			show	("5....4....3....2....1..........STOP!")
			wait(1.0)
		}
		else
		{
			showDynamically("5....4....3....2....1..........CUM!")
			getLeahImage("happy")
			show("5....4....3....2....1..........CUM!")
			wait(1.0)
			show("Good effort today, don't forget to come to practice tomorrow")
			wait(10.0)
		}
	}

	if(indicatorNope==1)		{
		if(cumScore > 70)
		{
			show("Good effort, but I don't like letting you finish today")
		}
		else
		{
			getLeahImage("punishment")
			show("Absolutely not, how dare even think I would entertain the thought after your abysmal performance today")
			wait(1.5)	
			getLeahImage("punishment")
			show("In fact your request reminded me, I shouldn't let you off so easily")
			wait(1.5)
			getLeahImage("punishment")
			show("Perhaps some extra work is required to show you exactly how many seconds "+timeGivenInSeconds+" is")
			wait(1.5)
			
			def i = 0
			while(i < 3)
			{
				startLeahPunishment()
				i = i+1
			}
			getLeahImage("punishment")
		}
		wait(2.0)
		show("Now, get out of my sight")
		wait(10.0)

	}
	
}






def startLeahBreatheHolding=
{
	
	while(currentCycle < maxCycle)
	{
		getLeahImage("holding")
		
		if(currentCycle == hideTimeAfterCycle)
		{
			show("Lets make this more fun, no more timers for you")
			wait(2.0)
		}

		if(currentCycle < hideTimeAfterCycle)
		{
			switch(lastAttempt)
			{
				case 0: 	show("I want you to stare only into my eyes for "+timeGivenInSeconds+" seconds.\n\nRemember, "+(1/countdownSpeed).toInteger()+" stroke per second")
						wait(1.0)
						break;
				case 1: 	show("Don't fuck up this time."+timeGivenInSeconds+" seconds.\n\nRemember, "+(1/countdownSpeed).toInteger()+" stroke per second")
						wait(1.0)
						break;
			}
		}
		else
		{
			switch(getRandom(10))
			{
			case 0: countdownSpeed = 1
					break;
			case 1: countdownSpeed = 1
					break;
			case 2: countdownSpeed = 0.5
					break;
			case 3: countdownSpeed = 0.5
					break;
			case 4: countdownSpeed = 0.5
					break;
			case 5: countdownSpeed = 0.5
					break;
			case 6: countdownSpeed = 0.25
					break;
			case 7: countdownSpeed = 0.25
					break;
			case 8: countdownSpeed = 0.25
					break;
			case 9:	countdownSpeed = 0.2
					break;
			}
			switch(lastAttempt)
			{
				case 0: 	show("Remember, "+(1/countdownSpeed).toInteger()+" stroke per second")
						wait(1.0)
						break;
				case 1: 	show("Don't fuck up this time."+(1/countdownSpeed).toInteger()+" stroke per second")
						wait(1.0)
						break;
			}
		}

		showButton("Holding")
		
		if(currentCycle < hideTimeAfterCycle)
		{		
			getLeahImage("holding")	
			waitWithCountDownSound("Remember, stare only into my eyes","tom.wav",timeGivenInSeconds,countdownSpeed)
		}
		else
		{		
			if(getRandom(100)>60)
			{
				getLeahImage("ass")
				show("Begin\n\nAnd stare only at my ass\nMy beautiful ass is the only thing stopping you from taking your next breathe")
				waitWithCountDownOnlySound("tom.wav",timeGivenInSeconds,countdownSpeed)
			}

			else if(getRandom(100)<15)
			{
				getLeahImage("challenge")
				waitWithCountDownSound("Remember, stare only into my eyes","tom.wav",timeGivenInSeconds / 3,countdownSpeed)
				getLeahImage("challenge")
				show("Now breath all the way out and keep your Loungs empty for me!")
				waitWithCountDownOnlySound("tom.wav",20,countdownSpeed)
				getLeahImage("challenge")
				show("Breath in deeply again and Hold it!")
				wait (5)
				waitWithCountDownSound("This time Im going to make you pass out!","tom.wav",timeGivenInSeconds / 2,countdownSpeed)
			}
			else
			{
				show("Begin")
			waitWithCountDownOnlySound("tom.wav",timeGivenInSeconds,countdownSpeed)
			}
		}
	
		switch(getSelectedValue("Did you finish",["Yes","No"]))
		{
		case 0: lastAttempt = 0
				calcAdditionalTime()
				break;
		case 1: lastAttempt = 1
				getLeahImage("punishment")
				if(currentFail < maxFail) 
				{
					show("Pathetic, it's not that difficult")
					wait(3.0)
					show("Perhaps I can persuade you to try harder next time")
					wait(2.0)
					getLeahImage("punishment")
					show("In case you weren't aware of exactly how long "+timeGivenInSeconds+" was, I'll try to show you")
					wait(2.0)
					startLeahPunishment()
				}
				else
				{
					show("Hopeless, this is a waste of my time")
					cumScore = cumScore + (-10000)
					currentCycle = maxCycle
				}
				break;
		}
		currentCycle = currentCycle + 1
	}
	
	switch(getSelectedValue("Would you like to cum?",["Yes","No"]))
	{
	case 0:	startLeahCumChance()
			break;
	case 1:	show("Good boy, run along now")
			break;
	}

}






def startLoopThroughInstructors=
{
	getLeahImage("Introduction")
	show("Myself! I don't believe any introduction is necessary")
	showButton("Next") 
	getLeahImage("Introduction")
	show("Angela! I don't believe any introduction is necessary")
	showButton("Next")
	getLeahImage("Introduction")
	show("Jessica! I don't believe any introduction is necessary")
	showButton("Next")
	getLeahImage("Introduction")
	show("Leslie! I don't believe any introduction is necessary")
	showButton("Next")
	getLeahImage("Introduction")
	show("Emily! I don't believe any introduction is necessary")
	showButton("Next")
}
def startLeahTest=
{
	getLeahImage("introduction")
	show("In order for me to get an idea of the optimal treatment for you "+loadString("intro.name")+",/n/n i would like you to absolve a little Test!")
	showButton("Continue")

	getLeahImage("introduction")
	show("in a moment I will command you to hold your breath for as long as you can!/n/nTo get valid results you shuld realax yourselve at first, get yourselve comfortable and calm down.\n\n")
	showButton("Im realaxed Mistress")

	show("I will keep an eye on you so dont even think about cheating me!/n/n /n/n Now breath out all the way to get that used dirty air out, and take a deeeeep breath in and hold it!")
	showButton("Holding!")
def timestamp = getTime();
getLeahImage("test")

show ("Hold Your Breath for me "+loadString("intro.name")+"")
wait(10)
getLeahImage("test")
show("Try your best and push yourselve as hard as you can!")
wait(10)
getLeahImage("test")
show ("Good boy, keep it Holding")
wait(10)
getLeahImage("test")
show("Try to realax and motivate yourselve by looking at my perfect body!")
wait(10)
getLeahImage("test")
show("Keep It Holding for me  "+loadString("intro.name")+"!! I count on you!")


showButton("Stop");
def timepassed = getTime() - timestamp;
	save("BreatheAcademy.MyTime", timepassed)

getLeahImage("introduction")
	if (timepassed > 45){

	show ("That was not too bad")
	showButton ("continue")
	}
	else if (timepassed < 45){

	save("advanced.status", "punishment")
	show ("Not even 45 seconds... that was weak! You need some Motivation!!! you should try HARDER next time!")
	showButton ("continue")

	}


}


def startLeahIntroduction=
{
	getLeahImage("introduction")
	show("I'm Leah, and welcome to the Breathe Academy "+loadString("intro.name")+"!")
	showButton("Continue")

	getLeahImage("introduction")
	show("At the Academy the only lesson that matters is breathe training, so make sure that you're in a safe environment where you can't hurt yourself.\n\nIn this training I want you to pinch your nose with your thumb and index finger so you can't breathe anymore.\n\nAnd of course, mouth closed,...don't try to be a smart ass!")
	showButton("Continue")

	getLeahImage("introduction")
	show("The objective is to train your breathing, so the rules are:\n\n-Only stroke when you're told\n\n-Only cum when you're told\n\n-Only breathe when you're told")
	showButton("Continue")


}




def startLeah = 
{
	show("Try to make me happy by being obedient and by not failing!")
	getLeahImage("idle")
	wait(5.0)

	//setImage("BreatheAcademy/Leah/Kneehigh/idle"+getRandom(6)+".jpg")
	show("Get on your knees! and get hard so we can begin")
	getLeahImage("idle")
 	showButton("Ready, Mistress")

	getLeahImage("idle")
	show("Lets warm up with an easy "+timeGivenInSeconds+" seconds, in this time I want you to hold your breathe and stroke once per second")
	showButton("Ready, Mistress")

	startLeahBreatheHolding()

}
// Here begins the 'real' execution of the code

// This variable tells us if the script has been just opened, or if we've returned from a
// background color change
def status = loadString("advanced.status") ?: "start"
if (status == "start") {
	// clean screen
	show(null)
	setImage(null)
	
	show("Welcome to Breathe Academy")
	wait(3)
	timeMytimeInSeconds = loadInteger("BreatheAcademy.MyTime")

	startLeahIntroduction()
	if (loadInteger("BreatheAcademy.MyTime")<45){
	startLeahTest()
	}
	else {
	switch(getSelectedValue("Would you like to redo the initial test?",["No Thank you","Yes Please"]))
	{
	case 0:	startLeah()
			break;
	case 1: startLeahTest()
			break;
	}

	save("advanced.status", "punishment")
	getLeahImage("BreatheAcademy/Leah/Dark/happy0.jpg")
	}
}
else if (status == "punishment") {
	show("My notice regarding our last training tells me that you have been disobedient! This will not be tolerated...")
	showButton("Next")

	show("Now its time for you to recieve your punishment!")
	showButton("Next")
startLeahPunishment()

	save("advanced.status", "start")
	getLeahImage("BreatheAcademy/Leah/Dark/happy0.jpg")
}


// This script is protected by this license: 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/

/*
 * Resources
 * scripts/BreatheAcademy.groovy
 * images/BreatheAcademy/Leah/Dark/*
 */
